(function() {
  var decodeLine, encodeLine;
  encodeLine = function(event) {
    var data, json;
    json = JSON.stringify(event);
    data = new Buffer(json, 'utf-8');
    return data.toString('base64') + "\n";
  };
  decodeLine = function(line) {
    var base64, data;
    if (typeof line !== 'string') {
      line = line.toString();
    }
    base64 = line.trim();
    data = new Buffer(base64, 'base64');
    return JSON.parse(data.toString());
  };
  module.exports = {
    encodeLine: encodeLine,
    decodeLine: decodeLine
  };
}).call(this);
